#
# spec file for package youtube
#
# Copyright (c) 2018 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via https://bugs.opensuse.org/
#


Name:           youtube
Version:        0.2.1.1
Release:        3.11
Summary:        Upload video to YouTube via YouTube API
License:        BSD-3-Clause
Group:          Development/Libraries/Haskell
URL:            https://hackage.haskell.org/package/%{name}
Source0:        https://hackage.haskell.org/package/%{name}-%{version}/%{name}-%{version}.tar.gz
BuildRequires:  ghc-Cabal-devel
BuildRequires:  ghc-bytestring-devel
BuildRequires:  ghc-process-devel
BuildRequires:  ghc-rpm-macros
BuildRequires:  ghc-utility-ht-devel

%description
Upload a video to YouTube via YouTube API. The aim of this program is to
simplify uploads of related videos.

First you must have the 'curl' executable installed.

In order to use the 'youtube-upload' command you need a YouTube account and an
additional developer account. From the developer account you get a keyfile.
If you want to upload videos you first have to login to YouTube. You can do
this with

> youtube-auth your_youtube_login

or

> export YOUTUBEUSER=your_youtube_login > youtube-auth

As a result of this call you get an authentication token. Write this
authentication token into the 'YOUTUBEAUTH' environment variable. It is queried
by 'youtube-upload'. For every upload you have to pass the developer keyfile,
an XML file containing meta data for the video and the video file.

The XML file must be encoded with UTF-8. I found it very useful to generate the
XML files from an XML template file and a CSV table using the 'cvsreplace'
command from the 'spreadsheet' package. I have included the example file
'upload-template.xml' that you can use with a CSV file with the columns
'TITLE', 'DESCRIPTION', 'CATEGORY', 'TAGS'.

The package is now deprecated. It only supports authentication via
'ClientLogin' which was disabled by Google somewhen in 2017.
Authentication via 'OAuth2.0' is pretty complicated. Better use a program that
calls one of the official Google APIs like:

* <https://github.com/tokland/youtube-upload>.

%prep
%setup -q

%build
%ghc_bin_build

%install
%ghc_bin_install

%files
%license LICENSE
%{_bindir}/youtube-auth
%{_bindir}/youtube-upload
%dir %{_datadir}/%{name}-%{version}
%dir %{_datadir}/%{name}-%{version}/src
%{_datadir}/%{name}-%{version}/src/upload-template.xml

%changelog
* Tue Jul 10 2018 psimons@suse.com
- Add youtube at version 0.2.1.1.
